/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.dashboard.web.client.internal.ItemNameRegistry");

(function() {

/*
 * A client-side data caching layer for the viewlet registry.
 */
com.ibm.team.dashboard.web.client.internal.ItemNameRegistry = {
	
	_namesByItemId: new Object(),
	
	addNames: function(/* ItemNameDTO[] */ itemNameDTOs) {
		for (var i=0;i<itemNameDTOs.length;i++) {
			this.addName(itemNameDTOs[i]);
		}
	},
	
	addName: function(/* ItemNameDTO */ dto) {
		this._namesByItemId[dto.itemId] = dto.name;
	},
	
	getName: function(/* string */ itemId) {
		if (this._namesByItemId[itemId])
			return this._namesByItemId[itemId];
		return null;
	}
};

})();
