/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005-2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.client.internal.mixins.PlanItem"); //$NON-NLS-1$

(function() { // module container

/**
 * This mixin is designed to be applied to WorkItemDTOs
 */
com.ibm.team.apt.web.client.internal.mixins.PlanItem= {
	
	// ---- API ------------------------------------------------------------------------------------------------------------	

	updateProgressInformation: function(progressInfo) {
		if (this.isProgressPlanItem()) {
			progressInfo.delta(this.progressInformation);
		} else if (this.countAsResolved()) {
			progressInfo.deltaCloseCount(1);
			progressInfo.deltaWorkHoursDone(this.estimate.duration);
		} else if (this.countAsOpen()) {
			progressInfo.deltaOpenCount(1);
			progressInfo.deltaWorkHoursLeft(this.estimate.duration);
			if(this.estimate.specified || this.isTopLevelPlanItem()) {
				progressInfo.deltaEstimateCount(1);
			}

			if (this.estimate.timeSpent >= 0) {
				progressInfo.deltaWorkHoursDone(this.estimate.timeSpent);
			}
		}
	},
	
	isProgressPlanItem: function() {
		return this.progressItem && this.progressInformation != null;
	},
	
	isTopLevelPlanItem: function() {
		return this.getWorkItemType().topLevel;
	},

	countAsOpen: function() {
		return !this.auxiliary && !this.resolved;
	},

	countAsResolved: function() {
		return !this.auxiliary && this.resolved;
	},

	// ---- implementation -------------------------------------------------------------------------------------------------

	__sentinel: null // terminates this class definition
};

})();