/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005-2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("com.ibm.team.process.web.ui.internal.TestPage"); //$NON-NLS-1$

dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$

dojo.require("net.jazz.ajax.ui.PlatformUI"); //$NON-NLS-1$

dojo.require("com.ibm.team.repository.web.client.init.InitializationData"); //$NON-NLS-1$

dojo.require("com.ibm.team.process.web.client.projectarea"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.process.web.ui.internal", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$

// aliases and utility functions

var InitializationData = com.ibm.team.repository.web.client.init.InitializationData;
var PlatformUI = net.jazz.ajax.ui.PlatformUI;

var TestPageMessages = dojo.i18n.getLocalization("com.ibm.team.process.web.ui.internal", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$

function getProjectAreaString(projectArea) {
	return "{itemId: " + projectArea.itemId + ", name: " + projectArea.name + "}"; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
}

dojo.declare("com.ibm.team.process.web.ui.internal.TestPage", [dijit._Widget, dijit._Templated], { //$NON-NLS-1$
	templateString: "<div><div dojoAttachPoint='allPAs'>${TestPageMessages.TestPage_1}<br/></div><div dojoAttachPoint='currentPA'><br/>${TestPageMessages.TestPage_2}<br/></div></div>", //$NON-NLS-1$
	
	postCreate: function() {
		var ActionRegistry = PlatformUI.getWorkbench().getActionRegistry();
		ActionRegistry.registerAction("com.ibm.team.process.web._testProjectAreas", this, "showProjectAreaInfo"); //$NON-NLS-1$ //$NON-NLS-2$
	},
	
	showProjectAreaInfo: function() {
		var self = this;
		
		var projectAreas = InitializationData.get("com.ibm.team.process.service.projectAreaWebUIInitializionData").projectAreas; //$NON-NLS-1$
		dojo.forEach(projectAreas, function(projectArea) {
			var div = document.createElement("div"); //$NON-NLS-1$
			div.innerHTML = getProjectAreaString(projectArea);
			self.allPAs.appendChild(div);
		});
		
		var projectArea = com.ibm.team.process.web.client.projectarea.getCurrentProjectArea();
		this.currentPA.appendChild(document.createTextNode(getProjectAreaString(projectArea)));
	}

});

})();