/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
({
	
	// General Error Messages
	
	'msgUnknownReportType': "Unknown report type",
	'msgReportLoadingFailed': "Report loading failed",
	'msgNoMatchingNormalReport': "No normal report corresponding to micro report: ${0}",
	'msgWrongNumberOfEntries': "The number of parameter names does not equal the number of parameter values: ${0} != ${1}",
	'msgURLGenerationFailed': "Drill-in URL generation failed",
	'msgNoParametersDefined': "No parameters defined",
	'msgNoProjectAreasDefined': "No project area values defined",
	'msgWrongNumberOfProjectAreas': "The number of project area values does not equal the number of project area children: ${0} != ${1}",
	'msgWrongNumberOfParameters': "The number of parameter values does not equal the number of parameter children: ${0} != ${1}",
	'msgParameterLoadingFailed': "Parameter loading failed",
	'msgPrefValueParsingFailed': "Failed to parse preference value: ${0}",
	'msgParamValueParsingFailed': "Failed to parse parameter value: ${0}",
	'msgError': "[Error] ${0}",
	'msgVariableIsNotAString': "Variable is not a string: ${0}",
	'msgVariableIsNull': "Variable is null: ${0}",
	'msgVariableIsZeroLength': "Variable is zero length: ${0}",	
	'msgVariableIsNotAnArray': "Variable is not an array: ${0}",
	'msgPropertyDoesNotExist': "Property does not exist: ${0}.${1}",
	'msgVariableIsNotANumber': "Variable is not a number: ${0}",
	'msgNotValidObjectType': "Variable is not a valid object type: ${0}",
	'msgNotValidBooleanType': "Variable is not a boolean: ${0}",
	'msgUnrecognizedPreference': "Unrecognized preference: ${0}",
	'msgPrefLoadingFailed': "Preference loading failed",
	'msgUnrecognizedReport': "Unrecognized report: ${0}",
	'msgReportSettingFailed': "Report setting failed",
	
	// Report Preference Provider Error Messages
	
	'msgErrorLoadingParams': "Error loading parameters",
	'msgPollingTimedOut': "[Error] Polling timed-out",
	'msgNumParamsExceedLimit': "[Warning] The number of parameters selected exceeds the allowable limit:\n${0} bytes > ${1} bytes.\n\nThe selected parameters were not updated.",
	
	// Preference Messages

	'msgSelect': "[Select...]",
	'msgNoAvailableOptions': "[No Available Options]",
	'msgAll': "All",

	// Actionable Status Messages
	
	'msgActionConfigureReport': "Click <0>here</0> to configure this report.",

	// Work Items Status Messages

	'msgNoWorkItemsFound': "No work items were found.",
	'msgNoDeferredWorkItemsFound': "No deferred work items were found.",
	'msgNoBlockingWorkItemsFound': "No blocking work items were found.",
	'msgNoOpenWorkItemsFound': "No open work items were found.",
	'msgNoClosedWorkItemsFound': "No closed work items were found.",
	'msgSeverity': "Severity",
	
	// Scrum Status Messages
	
	'msgNoStoryWorkItemsFound': "No story work items were found.",
	'msgNoWorkItemsEstimatesFound': "No work items with estimates specified were found.",
	'msgNoWorkItemsTimeSpentFound': "No work items with estimates and time spent data were found.",

	// Build Status Messages
	
	'msgNoBuildResultsFound': "No build results were found.",
	'msgNoJUnitDataFound': "No JUnit data was found.",
	'msgNoCodeCoverageFound': "No code coverage data was found.",
	'msgNoCompilationDataFound': "No compilation data was found.",
	'msgNoStaticDataFound': "No static analysis data was found.",
	'msgNoTestFailuresFound': "No test failures were found.",
	'msgNoTestRegressionsFound': "No test regressions were found.",
	'msgBuildDefinition': "Build Definition",
	'msgComponent': "Component",
	'msgDuration': "Duration",
	'msgIncompleteBuilds': "Include Incomplete Builds",
	'msgYes': "Yes",
	'msgNo': "No",

	// General Status Messages
	
	'msgMyTeamAreas': "My Team Areas",
	'msgCurrentIteration': "Current Iteration",
	'msgTeamArea': "Team Area",
	'msgCategory': "Category",
	'msgIteration': "Iteration",
	'msgLoading': "Loading...",
	'msgNoResultsFound': "No results were found."
	
})