/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui.internal.view.editor.parts.ValidatedAttributePart");

	dojo.require("dijit._Widget");
	dojo.require("dijit._Templated");

dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.WidgetUtil");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.TextWidget");
dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal", "WorkItemEditorMessages");
/*
 * This is a wrapper widget that provides the presentation and value
 * processing for Duration, presented in 
 */
(function() {

var WidgetUtil = com.ibm.team.workitem.web.ui.internal.view.layout.WidgetUtil;

/* defineWidget */ dojo.declare(
	"com.ibm.team.workitem.web.ui.internal.view.editor.parts.ValidatedAttributePart",
	[dijit._Widget, dijit._Templated],
	{
		
		templateString: '<div class="ValidatedAttributePart">' +
						'<div dojoAttachPoint="_content" style="position:relative;left:10px;"></div>' +
						'</div>',
      constructor: function() {
			this.messages = dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal", "WorkItemEditorMessages");
		},	
		postCreate: function() {
			/*
			 * values[0]
			 *    label
			 *    validationRegex
			 *    id
			 */
			
			if(this.values && this.values[0]) {
 				if (this.values[0].validationRegex) {
					this.validationRegex = this.values[0].validationRegex;
					this.validationMessage = this.values[0].validationMessage ? this.values[0].validationMessage : this.messages.msgValueNotValid;
				}
			} else {
				this.values = [ "" ]
			}

			if (!this.validationRegex && this.creationSpec.validationRegex) {
				this.validationRegex = this.creationSpec.validationRegex;
				this.validationMessage = this.creationSpec.validationMessage ? this.creationSpec.validationMessage : this.messages.msgValueNotValid;
			}

			this.isNumber = this.creationSpec.isNumber == true;
			if(!this.attributeValue) {
				this.attributeValue = {
					label: ""
				}
			} else {
				if(!this.attributeValue.label && this.attributeValue.content) {
					this.attributeValue.label = this.attributeValue.content
				}
			}
			
			var creationArgs = {
						parentWidget: this,
						parentController: this.parentController,
						presentation: {
							attribute: {
								attributeTypeId: "ValidatedAttribute"
							}
						},
						selection:  [ {
							id: this.attributeValue.label
							} 
						 ] ,
						 converter: this._TextWidget_ValidatedAttributeConverter,
						 converterParms: {
						 		toolTip: this.validationMessage,
								value: this.values[0]
						 }
					};
					
			this.inputWidget = new com.ibm.team.workitem.web.ui.internal.view.layout.TextWidget(creationArgs);
			this.inputWidget.domNode.style.maxWidth = "19em";
			this.inputWidget._textInput.style.width = "85%";
			
			if(this.parentController.pageController.isGuest()) {
				dojo.addClass(this.inputWidget._textInput, "GuestField");
			}
			
			this._content.appendChild(this.inputWidget.domNode);
		},
		setReadOnly: function(isReadOnly) {
			this.inputWidget.setReadOnly(isReadOnly);
		},
		getFormElementValues: function(formElements) {
			var value = this.getValue();
			if(this.isNumber) {
				value = value.replace(/,/g, "");
			}
			if(this.isBoolean) {
				value = value=="t" || value =="true";
			}
			
			if(value) {
					formElements[this.attributeId] = value;
				} else {
					formElements[this.attributeId] = "";
				}
		},
		setFormElementValues: function(retainedState){
			var value = retainedState[this.attributeId];
			if(value) {
				this.inputWidget._textInput.value = value; // TODO: Create setValue API
			}
			},
	     getValue: function() {
			return this.inputWidget._textInput.value;
		 },
	//* This runs in the context of TextWidget
		//
		_TextWidget_ValidatedAttributeConverter: function (value, parms, isGettingValidValue) {
			return this.parentWidget._validationConverter(value, parms, isGettingValidValue);
		},
		_validationConverter: function (value, parms, isGettingValidValue) {
			var valid = false;
			if(!this.validationRegex || !value || value.length == 0) {
				valid = true;
			} 

			if(value && this.validationRegex && value.length > 0) {
				try{
					var regex = new RegExp("^" + this.validationRegex + "$");
 					valid = value.search(regex) != -1;
				} catch(e) {
					console.debug("Invalid regular expression for ValidateAttributePart: " + this.validationRegex);
					valid = true;
				}

			} 
			
			if(isGettingValidValue) {
				if(!value || value.length == 0) {
					return "";
				}				
				return value;
			}

			return {isCustom: true, isValid: valid };
		}
	}
)

})();
