/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005-2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.view.plan.planneditems.SortModes"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.common.Assert"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$
dojo.require("dojo.i18n"); //$NON-NLS-1$

(function() {
	
var bind= dojo.string.substitute;
var MSGS= dojo.i18n.getLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$ 

var Assert= com.ibm.team.apt.web.ui.internal.common.Assert;

function priority(treeNodeA, treeNodeB) {
	// TODO this assumes that the id's are orderes
	
	var prioA= treeNodeA.getNodeValue().priority;
	var prioB= treeNodeB.getNodeValue().priority;

	if (prioA != prioB) {
		return prioA < prioB ? 1 : -1;
	}
	
	return treeNodeB.getNodeValue().workItemId - treeNodeA.getNodeValue().workItemId; 
}

priority.id= "priority"; //$NON-NLS-1$
priority.label= MSGS.SORTMODE_PRIORITY;

	
function estimate(treeNodeA, treeNodeB) {
	var estimateA= treeNodeA.getNodeValue().estimate.duration;
	var estimateB= treeNodeB.getNodeValue().estimate.duration;

	if (estimateA != estimateB) {
		return estimateA < estimateB ? 1 : -1;
	}
	
	return treeNodeB.getNodeValue().workItemId - treeNodeA.getNodeValue().workItemId; 
}

estimate.id= "estimate"; //$NON-NLS-1$
estimate.label= MSGS.SORTMODE_ESTIMATE;

var UNKNOWN_SORT_INDEX= 1 << 30;

function _getMySortOrderIndex(workItem, folderId) {
	if (dojo.isArray(workItem.mySortOrder)) {
		for (var i= 0; i < workItem.mySortOrder.length; i++) {
			if (workItem.mySortOrder[i].folder == folderId)
				return workItem.mySortOrder[i].index;
		}
	}
	return UNKNOWN_SORT_INDEX;
}

function _getMyFolderId(treeNode) {
	while (treeNode != null) {
		if (treeNode.getNodeType() == "group") { //$NON-NLS-1$
			return treeNode.getNodeId();
		}
		
		treeNode= treeNode.getParent();
	}
	
	return null;
}

function mysortorder(treeNodeA, treeNodeB) {
	if (treeNodeA === treeNodeB)
		return 0;
	
	var indexA= UNKNOWN_SORT_INDEX;
	var indexB= UNKNOWN_SORT_INDEX;
	
	Assert.isTrue(treeNodeA.getParent() === treeNodeB.getParent());

	var folderId= _getMyFolderId(treeNodeA);	
	if (folderId != null) {
		indexA= _getMySortOrderIndex(treeNodeA.getNodeValue(), folderId);
		indexB= _getMySortOrderIndex(treeNodeB.getNodeValue(), folderId);
	}

	if (indexA != indexB)
		return indexA - indexB;
		
	return treeNodeB.getNodeValue().workItemId - treeNodeA.getNodeValue().workItemId; 
}

mysortorder.id= "mysortorder"; //$NON-NLS-1$
mysortorder.label= MSGS.SORTMODE_MYSORTMODE;

// publish methods
dojo.mixin(com.ibm.team.apt.web.ui.internal.view.plan.planneditems.SortModes,  {
	priority: priority,
	estimate: estimate,
	mysortorder: mysortorder
});


})();
