/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2008. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui.internal.view.queryeditor.widgets.TeamAreaWidget");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.team.process.web.client.projectarea");

dojo.require("com.ibm.team.workitem.web.ui.internal.view.queryeditor.widgets.ListWidget");
dojo.require("com.ibm.team.workitem.web.client.internal.ImageClient");
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
dojo.require("com.ibm.team.workitem.web.client.internal.WorkItemClient");

(function(){
	
var ImageClient= com.ibm.team.workitem.web.client.internal.ImageClient;
var ServiceResponseHandler= com.ibm.team.repository.web.transport.ServiceResponseHandler;
var WorkItemClient= com.ibm.team.workitem.web.client.internal.WorkItemClient;

var ListWidget= com.ibm.team.workitem.web.ui.internal.view.queryeditor.widgets.ListWidget;

dojo.declare("com.ibm.team.workitem.web.ui.internal.view.queryeditor.widgets.TeamAreaWidget", ListWidget, {

	///////////////////////////////////////////////////////////////////////////////////
	// API
	
	postCreate: function() {
		
		this._select.size= 10;
		this._select.multiple= "multiple";
		
		var attributeId= this.presentation.attribute.id;
		var srh= new ServiceResponseHandler(this, "_initTeamAreas", "_handleError");
		WorkItemClient.getProcessAreaHierarchies(srh);
	},
	
	///////////////////////////////////////////////////////////////////////////////////
	// Internals
	
	_initTeamAreas: function(processAreaHierarchy) {
		
		var teamAreas= new Array();
		var projectArea= this._findProjectArea(processAreaHierarchy);
		
		this._collectTeamAreas(projectArea.children, teamAreas, "");
		
		this._select.length= 0;
		this._addValues(teamAreas);
		this._selectValues(this.selection);
	},
	
	_findProjectArea: function(processAreaHierarchy) {
		var itemId= com.ibm.team.process.web.client.projectarea.getCurrentProjectArea().itemId;
		for (var i= 0; i < processAreaHierarchy.length; i++) {
			if (processAreaHierarchy[i].itemId == itemId)
				return processAreaHierarchy[i];
		}
		return null;
	},
	
	_collectTeamAreas: function(teamAreas, collector, indent) {
		if (teamAreas) {
			for (var i= 0; i < teamAreas.length; i++) {
				var team= teamAreas[i];
				var item= { id: team.itemId, label: indent + team.name};
				collector.push(item);
				this._collectTeamAreas(team.children, collector, indent + "   ");
			}
		}
	}
	
});
	
})();
